// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.api.yaml;

import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.system.T2C_Main;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class T2C_ConfigWriter {

    private static FileConfiguration config;

    public static void createConfig(File configFile, T2C_ConfigItem[] values, String... header) {
        boolean exist = configFile.exists();
        if (!exist) {
            configFile.getParentFile().mkdirs();
            try {
                configFile.createNewFile();
            } catch (IOException e) {
                T2C_Send.sendException(e, T2C_Main.getPlugin().getLogger());
                return;
            }
        } else exist = true;

        config = YamlConfiguration.loadConfiguration(configFile);
        Map<String, List<String>> comments = new LinkedHashMap<>();

        T2C_LanguageEnum lang = T2C_LanguageEnum.english;
        try {
            lang = T2C_LanguageEnum.valueOf(config.getString(values[0].getLanguagePath().replace(".yml", "")));
        } catch (Exception ignore) {
        }

        for (T2C_ConfigItem item : values) {
            if (item.getForceSet() || !exist) {
                config.addDefault(item.getPath(), item.getValue());

                List<String> commandList = item.getComments().get(lang);
                if (commandList != null) {
                    comments.put(item.getPath(), commandList);
                }
            }
        }

        // Copy default values if they are missing
        config.options().copyDefaults(true);

        T2C_YmlWriter.saveConfigWithComments(configFile, config, comments, header);
        readConfig(config, values);
    }

    private static void readConfig(FileConfiguration config, T2C_ConfigItem[] values) {
        for (T2C_ConfigItem value : values) {
            value.setValue(config.get(value.getPath()));
        }
    }
}
